import struct

class Stroke:

	def __init__(self, colour, zoom, size):
		self.colour = colour
		self.zoom = zoom
		self.size = size
		self.lines = []

	def addLine(self, start, end):
		self.lines.append((start,end))

class Scribble:

	def __init__(self):
		self.strokes = []

	def loadFromData(self, data):
		sptr = 0x28
		while sptr<len(data)-12:
			# colour : zoom : ? : ? : size : num points
			hdr = struct.unpack_from("IfIIII", data, sptr)
			stroke = Stroke(hdr[0], hdr[1], hdr[4])
			numpoints = hdr[5]
			sptr += 24
			oldpt = None
			for i in range(numpoints):
				# x : y : ?
				spt = struct.unpack_from("III", data, sptr)
				sptr += 12
				# zoom factor?
				x = spt[0]*48.0/stroke.zoom
				y = spt[1]*48.0/stroke.zoom
				newpt = (x,y)
				if oldpt:
					stroke.addLine(oldpt, newpt)
					oldpt = newpt
				else:
					oldpt = newpt
			self.strokes.append(stroke)
